Package org.apache.sis.referencing.datum

## Class DefaultPrimeMeridian

- Object
- - FormattableObject
  - - AbstractIdentifiedObject
    - - DefaultPrimeMeridian

- All Implemented Interfaces:
    `Serializable`, `Deprecable`, `LenientComparable`, `PrimeMeridian`, `IdentifiedObject`

      public class DefaultPrimeMeridian
      extends AbstractIdentifiedObject
      implements PrimeMeridian

  Defines the origin from which longitude values are determined.
  Creating new prime meridian instances
  New instances can be created either directly by specifying all information to a factory method (choices 3 and 4 below), or indirectly by specifying the identifier of an entry in a database (choices 1 and 2 below). In particular, the EPSG database provides definitions for many prime meridians, and Apache SIS provides convenience shortcuts for some of them.

  Choice 1 in the following list is the easiest but most restrictive way to get a prime meridian. The other choices provide more freedom. Each choice delegates its work to the subsequent items (in the default configuration), so this list can been seen as top to bottom API.

  1. Create a `PrimeMeridian` from one of the static convenience shortcuts listed in `CommonCRS​.primeMeridian()`.
  2. Create a `PrimeMeridian` from an identifier in a database by invoking `DatumAuthorityFactory​.createPrimeMeridian(String)`.
  3. Create a `PrimeMeridian` by invoking the `DatumFactory​.createPrimeMeridian(…)` method (implemented for example by `GeodeticObjectFactory`).
  4. Create a `DefaultPrimeMeridian` by invoking the constructor.
  Example: the following code gets the Greenwich prime meridian:

  >     PrimeMeridian pm = CommonCRS.WGS84.primeMeridian();

  Immutability and thread safety
  This class is immutable and thus thread-safe if the property values (not necessarily the map itself) given to the constructor are also immutable. Unless otherwise noted in the javadoc, this condition holds if all components were created using only SIS factories and static constants.
  Since:
    0.4
  See Also:
    `CommonCRS​.primeMeridian()`, `GeodeticAuthorityFactory​.createPrimeMeridian(String)`, Serialized Form

  Defined in the `sis-referencing` module

- - ### Field Summary

    - ### Fields inherited from class AbstractIdentifiedObject

      `DEPRECATED_KEY, LOCALE_KEY`

    - ### Fields inherited from interface IdentifiedObject

      `ALIAS_KEY, IDENTIFIERS_KEY, NAME_KEY, REMARKS_KEY`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `` | `DefaultPrimeMeridian​(Map<String,​?> properties, double greenwichLongitude, Unit<Angle> angularUnit)` | Creates a prime meridian from the given properties.
    `protected` | `DefaultPrimeMeridian​(PrimeMeridian meridian)` | Creates a new prime meridian with the same values than the specified one.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static DefaultPrimeMeridian` | `castOrCopy​(PrimeMeridian object)` | Returns a SIS prime meridian implementation with the same values than the given arbitrary implementation.
    `protected long` | `computeHashCode()` | Invoked by `hashCode()` for computing the hash code when first needed.
    `boolean` | `equals​(Object object, ComparisonMode mode)` | Compares this prime meridian with the specified object for equality.
    `protected String` | `formatTo​(Formatter formatter)` | Formats this prime meridian as a Well Known Text `PrimeMeridian[…]` element.
    `Unit<Angle>` | `getAngularUnit()` | Returns the angular unit of the Greenwich longitude.
    `double` | `getGreenwichLongitude()` | Longitude of the prime meridian measured from the Greenwich meridian, positive eastward.
    `double` | `getGreenwichLongitude​(Unit<Angle> unit)` | Returns the longitude value relative to the Greenwich Meridian, expressed in the specified units.
    `Class<? extends PrimeMeridian>` | `getInterface()` | Returns the GeoAPI interface implemented by this class.

    - ### Methods inherited from class AbstractIdentifiedObject

      `castOrCopy, equals, getAlias, getDescription, getIdentifiers, getName, getRemarks, hashCode, isDeprecated, isHeuristicMatchForName`

    - ### Methods inherited from class FormattableObject

      `print, toString, toString, toWKT`

    - ### Methods inherited from class Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface IdentifiedObject

      `getAlias, getIdentifiers, getName, getRemarks, toWKT`

- - ### Constructor Detail

    - #### DefaultPrimeMeridian

          public DefaultPrimeMeridian​(Map<String,​?> properties,
                                      double greenwichLongitude,
                                      Unit<Angle> angularUnit)

      Creates a prime meridian from the given properties. The properties map is given unchanged to the super-class constructor. The following table is a reminder of main (not all) properties:

      Recognized properties (non exhaustive list)
      Property name | Value type | Returned by
      --- | --- | ---
      "name" | `ReferenceIdentifier` or `String` | `AbstractIdentifiedObject.getName()`
      "alias" | `GenericName` or `CharSequence` (optionally as array) | `AbstractIdentifiedObject.getAlias()`
      "identifiers" | `ReferenceIdentifier` (optionally as array) | `AbstractIdentifiedObject.getIdentifiers()`
      "remarks" | `InternationalString` or `String` | `AbstractIdentifiedObject.getRemarks()`

      Parameters:
        `properties` - the properties to be given to the identified object.
        `greenwichLongitude` - the longitude value relative to the Greenwich Meridian.
        `angularUnit` - the angular unit of the longitude.
      See Also:
        `GeodeticObjectFactory​.createPrimeMeridian(Map, double, Unit)`

    - #### DefaultPrimeMeridian

          protected DefaultPrimeMeridian​(PrimeMeridian meridian)

      Creates a new prime meridian with the same values than the specified one. This copy constructor provides a way to convert an arbitrary implementation into a SIS one or a user-defined one (as a subclass), usually in order to leverage some implementation-specific API.

      This constructor performs a shallow copy, i.e. the properties are not cloned.

      Parameters:
        `meridian` - the prime meridian to copy.
      See Also:
        `castOrCopy(PrimeMeridian)`

  - ### Method Detail

    - #### castOrCopy

          public static DefaultPrimeMeridian castOrCopy​(PrimeMeridian object)

      Returns a SIS prime meridian implementation with the same values than the given arbitrary implementation. If the given object is `null`, then this method returns `null`. Otherwise if the given object is already a SIS implementation, then the given object is returned unchanged. Otherwise a new SIS implementation is created and initialized to the attribute values of the given object.
      Parameters:
        `object` - the object to get as a SIS implementation, or `null` if none.
      Returns:
        a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

    - #### getInterface

          public Class<? extends PrimeMeridian> getInterface()

      Returns the GeoAPI interface implemented by this class. The SIS implementation returns `PrimeMeridian​.class`.
      Note for implementers: Subclasses usually do not need to override this method since GeoAPI does not define `PrimeMeridian` sub-interface. Overriding possibility is left mostly for implementers who wish to extend GeoAPI with their own set of interfaces.
      Overrides:
        `getInterface` in class `AbstractIdentifiedObject`
      Returns:
        `PrimeMeridian​.class` or a user-defined sub-interface.

    - #### getGreenwichLongitude

          public double getGreenwichLongitude()

      Longitude of the prime meridian measured from the Greenwich meridian, positive eastward.
      Specified by:
        `getGreenwichLongitude` in interface `PrimeMeridian`
      Returns:
        the prime meridian Greenwich longitude, in angular unit.

    - #### getGreenwichLongitude

          public double getGreenwichLongitude​(Unit<Angle> unit)

      Returns the longitude value relative to the Greenwich Meridian, expressed in the specified units. This convenience method makes it easier to obtain longitude in decimal degrees using the following code, regardless of the underlying angular units of this prime meridian:

      >     double longitudeInDegrees = primeMeridian.getGreenwichLongitude(Units.DEGREE);

      Parameters:
        `unit` - the unit in which to express longitude.
      Returns:
        the Greenwich longitude in the given units.

    - #### getAngularUnit

          public Unit<Angle> getAngularUnit()

      Returns the angular unit of the Greenwich longitude.
      Specified by:
        `getAngularUnit` in interface `PrimeMeridian`
      Returns:
        the angular unit of the Greenwich longitude.

    - #### equals

          public boolean equals​(Object object,
                                ComparisonMode mode)

      Compares this prime meridian with the specified object for equality.
      Specified by:
        `equals` in interface `LenientComparable`
      Overrides:
        `equals` in class `AbstractIdentifiedObject`
      Parameters:
        `object` - the object to compare to `this`.
        `mode` - `STRICT` for performing a strict comparison, or `IGNORE_METADATA` for comparing only properties relevant to coordinate transformations.
      Returns:
        `true` if both objects are equal.
      See Also:
        `AbstractIdentifiedObject​.computeHashCode()`, `Utilities​.deepEquals(Object, Object, ComparisonMode)`

    - #### computeHashCode

          protected long computeHashCode()

      Invoked by `hashCode()` for computing the hash code when first needed. See `AbstractIdentifiedObject​.computeHashCode()` for more information.
      Overrides:
        `computeHashCode` in class `AbstractIdentifiedObject`
      Returns:
        the hash code value. This value may change in any future Apache SIS version.

    - #### formatTo

          protected String formatTo​(Formatter formatter)

      Formats this prime meridian as a Well Known Text `PrimeMeridian[…]` element.
      Overrides:
        `formatTo` in class `AbstractIdentifiedObject`
      Parameters:
        `formatter` - the formatter where to format the inner content of this WKT element.
      Returns:
        `"PrimeMeridian"` (WKT 2) or `"PrimeM"` (WKT 1).
      See Also:
        WKT 2 specification §8.2.2